/*
// From unmodified hal-i386.
0000015c <ath_hal_probe>:
     15c:	8b 54 24 04          	mov    0x4(%esp),%edx
     160:	8b 44 24 08          	mov    0x8(%esp),%eax
     164:	66 81 fa 8c 16       	cmp    $0x168c,%dx
     169:	74 13                	je     17e <ath_hal_probe+0x22>
     16b:	66 81 fa 27 a7       	cmp    $0xa727,%dx
     170:	74 0c                	je     17e <ath_hal_probe+0x22>
     172:	b9 00 00 00 00       	mov    $0x0,%ecx
     177:	66 81 fa b7 10       	cmp    $0x10b7,%dx
     17c:	75 0e                	jne    18c <ath_hal_probe+0x30>
     17e:	0f b7 c0             	movzwl %ax,%eax
     181:	50                   	push   %eax
     182:	e8 79 fe ff ff       	call   0 <ath_hal_probe-0x15c>
     187:	83 c4 04             	add    $0x4,%esp
     18a:	89 c1                	mov    %eax,%ecx
     18c:	89 c8                	mov    %ecx,%eax
     18e:	c3                   	ret    
     18f:	90                   	nop    
*/

// Sadly all of ath_hal_probe is pretty much worthless since we can simply 
// replace it with if(vendorid == ourvendor && devid == ourdev) pretty easily.
const char *__ahdecl ath_hal_probe(u_int16_t vendorid, u_int16_t devid)
{
	if (a == 0x168c || a == 0xa727 || a == 0x10b7) {
		return ath_hal_probe_i(b);
	}
	return 0;
}

/*
00000000 <ath_hal_probe-0x15c>:
       0:	0f b7 44 24 04       	movzwl 0x4(%esp),%eax
       5:	ba 3f 00 00 00       	mov    $0x3f,%edx
       a:	83 f8 58             	cmp    $0x58,%eax
       d:	0f 84 45 01 00 00    	je     158 <ath_hal_probe-0x4>
      13:	83 f8 58             	cmp    $0x58,%eax
      16:	7f 7c                	jg     94 <ath_hal_probe-0xc8>
      18:	83 f8 1b             	cmp    $0x1b,%eax
      1b:	7f 33                	jg     50 <ath_hal_probe-0x10c>
      1d:	83 f8 1a             	cmp    $0x1a,%eax
      20:	0f 8d 12 01 00 00    	jge    138 <ath_hal_probe-0x24>
      26:	83 f8 12             	cmp    $0x12,%eax
      29:	7f 17                	jg     42 <ath_hal_probe-0x11a>
      2b:	83 f8 11             	cmp    $0x11,%eax
      2e:	0f 8d ec 00 00 00    	jge    120 <ath_hal_probe-0x3c>
      34:	83 f8 07             	cmp    $0x7,%eax
      37:	0f 84 db 00 00 00    	je     118 <ath_hal_probe-0x44>
      3d:	e9 0e 01 00 00       	jmp    150 <ath_hal_probe-0xc>
      42:	83 f8 13             	cmp    $0x13,%eax
      45:	0f 84 ed 00 00 00    	je     138 <ath_hal_probe-0x24>
      4b:	e9 00 01 00 00       	jmp    150 <ath_hal_probe-0xc>
      50:	83 f8 24             	cmp    $0x24,%eax
      53:	0f 84 ed 00 00 00    	je     146 <ath_hal_probe-0x16>
      59:	83 f8 24             	cmp    $0x24,%eax
      5c:	7f 1c                	jg     7a <ath_hal_probe-0xe2>
      5e:	ba 52 00 00 00       	mov    $0x52,%edx
      63:	83 f8 1c             	cmp    $0x1c,%eax
      66:	0f 84 ec 00 00 00    	je     158 <ath_hal_probe-0x4>
      6c:	83 f8 23             	cmp    $0x23,%eax
      6f:	0f 84 ca 00 00 00    	je     13f <ath_hal_probe-0x1d>
      75:	e9 d6 00 00 00       	jmp    150 <ath_hal_probe-0xc>
      7a:	83 f8 52             	cmp    $0x52,%eax
      7d:	0f 84 a4 00 00 00    	je     127 <ath_hal_probe-0x35>
      83:	83 f8 57             	cmp    $0x57,%eax
      86:	0f 84 9b 00 00 00    	je     127 <ath_hal_probe-0x35>
      8c:	e9 bf 00 00 00       	jmp    150 <ath_hal_probe-0xc>
      // Is it impossible to get to 91? I think so..
      91:	8d 76 00             	lea    0x0(%esi),%esi
      94:	3d 12 11 00 00       	cmp    $0x1112,%eax
      99:	0f 84 81 00 00 00    	je     120 <ath_hal_probe-0x3c>
      9f:	3d 12 11 00 00       	cmp    $0x1112,%eax
      a4:	7f 3a                	jg     e0 <ath_hal_probe-0x7c>
      a6:	ba 64 00 00 00       	mov    $0x64,%edx
      ab:	3d 91 00 00 00       	cmp    $0x91,%eax
      b0:	0f 84 a2 00 00 00    	je     158 <ath_hal_probe-0x4>
      b6:	3d 91 00 00 00       	cmp    $0x91,%eax
      bb:	7f 10                	jg     cd <ath_hal_probe-0x8f>
      bd:	2d 86 00 00 00       	sub    $0x86,%eax
      c2:	83 f8 01             	cmp    $0x1,%eax
      c5:	0f 87 85 00 00 00    	ja     150 <ath_hal_probe-0xc>
      cb:	eb 61                	jmp    12e <ath_hal_probe-0x2e>
      cd:	3d 14 10 00 00       	cmp    $0x1014,%eax
      d2:	74 64                	je     138 <ath_hal_probe-0x24>
      d4:	3d 07 11 00 00       	cmp    $0x1107,%eax
      d9:	74 3d                	je     118 <ath_hal_probe-0x44>
      db:	eb 73                	jmp    150 <ath_hal_probe-0xc>
      // Is it impossible to get to dd also? I think so..
      dd:	8d 76 00             	lea    0x0(%esi),%esi
      e0:	ba 77 00 00 00       	mov    $0x77,%edx
      e5:	3d 1b f1 00 00       	cmp    $0xf11b,%eax
      ea:	74 6c                	je     158 <ath_hal_probe-0x4>
      ec:	3d 1b f1 00 00       	cmp    $0xf11b,%eax
      f1:	7f 15                	jg     108 <ath_hal_probe-0x54>
      f3:	3d 13 11 00 00       	cmp    $0x1113,%eax
      f8:	74 3e                	je     138 <ath_hal_probe-0x24>
      fa:	ba 8b 00 00 00       	mov    $0x8b,%edx
      ff:	3d 13 f0 00 00       	cmp    $0xf013,%eax
     104:	74 52                	je     158 <ath_hal_probe-0x4>
     106:	eb 48                	jmp    150 <ath_hal_probe-0xc>
     108:	3d 1c ff 00 00       	cmp    $0xff1c,%eax
     10d:	74 37                	je     146 <ath_hal_probe-0x16>
     10f:	3d 1d ff 00 00       	cmp    $0xff1d,%eax
     114:	74 29                	je     13f <ath_hal_probe-0x1d>
     116:	eb 38                	jmp    150 <ath_hal_probe-0xc>
     118:	ba 9f 00 00 00       	mov    $0x9f,%edx
     11d:	eb 39                	jmp    158 <ath_hal_probe-0x4>
     11f:	90                   	nop    
     120:	ba ac 00 00 00       	mov    $0xac,%edx
     125:	eb 31                	jmp    158 <ath_hal_probe-0x4>
     127:	ba b9 00 00 00       	mov    $0xb9,%edx
     12c:	eb 2a                	jmp    158 <ath_hal_probe-0x4>
     12e:	ba cc 00 00 00       	mov    $0xcc,%edx
     133:	eb 23                	jmp    158 <ath_hal_probe-0x4>
     135:	8d 76 00             	lea    0x0(%esi),%esi
     138:	ba df 00 00 00       	mov    $0xdf,%edx
     13d:	eb 19                	jmp    158 <ath_hal_probe-0x4>
     13f:	ba ec 00 00 00       	mov    $0xec,%edx
     144:	eb 12                	jmp    158 <ath_hal_probe-0x4>
     146:	ba f9 00 00 00       	mov    $0xf9,%edx
     14b:	eb 0b                	jmp    158 <ath_hal_probe-0x4>
     14d:	8d 76 00             	lea    0x0(%esi),%esi
     150:	ba 00 00 00 00       	mov    $0x0,%edx
     155:	8d 76 00             	lea    0x0(%esi),%esi
     158:	89 d0                	mov    %edx,%eax
     15a:	c3                   	ret    
     15b:	90                   	nop    
*/

int ath_hal_probe_i(int b)
{
	int d = 0x3f;
	if(b != 0x58) {
		if (b <= 0x58) {
			if (b <= 0x1b) {
				if (b < 0x1a) {
					if (b <= 0x12) {
						if (b < 0x11) {
							if (b != 0x7) {
								goto p150;
							} else {
								goto p118;
							}
						} else {
							goto p120;
						}
					} else { // 42
						if (b != 0x13) {
							goto p150;
						} else {
							goto p138;
						}
					}
				}
			} else { // 50
				if (b != 0x24) {
					if (b <= 0x24) {
						d = 0x52;
						if (b != 0x1c) {
							if (b != 0x23) {
								goto p150;
							} else {
								goto p13f;
							}
						} else {
							return d;
						}
					} else { // 7a
						if (b != 0x52) {
							if (b != 0x57) {
								goto p150;
							} else {
								goto p127;
							}
						} else {
							goto p127;
						}
					}
				} else {
					goto p146;
				}
			}
			
		} else { // 94
			if (b != 0x1112) {
				if (b <= 0x1112) {
					d = 0x64;
					if (b != 0x91) {
						if (b <= 0x91) {
							if (b - 0x86 != 0) {
								goto p150;
							} else {
								goto p12e;
							}
						} else { // cd
							if (b != 0x1014) {
								if (b != 0x1107) {
									goto p150;
								} else {
									goto p118;
								}
							} else {
								goto p138;
							}
						}
					} else {
						return d;
					}
					
				} else { // e0
					d = 0x77;
					if (b != 0xf11b) {
						if (b <= 0xf11b) {
							if (b != 0x1113) {
								d = 0x8b;
								if (b != 0xf013) {
									goto p150;
								} else {
									return d;
								}
							} else {
								goto p138;
							}
						} else {
							goto p108;
						}
					} else {
						return d;
					}
				}
			} else {
				goto p120;
			}
		}
		
	} else {
		return d;
	}
// The following are probably part of the else but it doesn't matter so much.
p108:
	if (b == 0xff1c) {
		goto p146;
	} else {
		if (b == 0xff1d) {
			goto p13f;
		}
		goto p150;
	}
p118:
	d = 0x9f;
	return d;
p120:
	d = 0xac;
	return d;
p127:
	d = 0xb9;
	return d;
p12e:
	d = 0xcc;
	return d;
p138:
	d = 0xdf;
	return d;
p13f:
	d = 0xec;
	return d;
p146:
	d = 0xf9;
	return d;
p150:
	d = 0;
	__asm__("lea    0x0(%esi),%esi");
	return d;
}
